INCLUDE "STANDARD.BI"
DIM SCRATCHBANK AS BYTE

DIM RIFFHDR AS STRING*44 @$A000
DIM WAVFILE AS STRING * 96

FUNCTION ISAWAVEHDR AS BYTE(HDR AS STRING*96) STATIC
 RETURN (LEFT$(HDR,4) = "riff") AND (MID$(HDR,8,4)="wave")
END FUNCTION

FUNCTION IsPCM AS BYTE(HDR AS STRING*96) STATIC
DIM TMP1 AS BYTE
DIM TMP2 AS BYTE
DIM TMP3 AS WORD
 TMP1 = ASC(MID$(HDR,20,1))
 TMP2 = ASC(MID$(HDR,21,1))
 TMP3 = TMP1 + CWORD(256*TMP2)
 RETURN (TMP3=1)
END FUNCTION

FUNCTION PCMBits AS BYTE(HDR AS STRING*96) STATIC
 RETURN ASC(MID$(HDR,34,1))
END FUNCTION

FUNCTION NumChannels AS BYTE(HDR AS STRING*96) STATIC
 RETURN ASC(MID$(HDR,22,1))
END FUNCTION

FUNCTION SampleRate AS LONG(HDR AS STRING*96)
 DIM TMP1 AS WORD
 DIM TMP2 AS WORD
 DIM TMP3 AS LONG
 TMP1 = ASC(MID$(HDR,24,1))
 TMP2 = ASC(MID$(HDR,25,1)) * 256
 TMP3 = ASC(MID$(HDR,26,1)) * 65536
 RETURN TMP1+TMP2+TMP3
END FUNCTION

SCRATCHBANK = 63

PRINT "{CLR}"
PRINT ""
INPUT "enter wav file name: ";WAVFILE

OPEN 4,8,4,WAVFILE+",s,r"

ASM
 lda {SCRATCHBANK}
 sta 0
 lda #44
 sta {RIFFHDR}
 ldx #4
 jsr {CHKIN}
 ldx #$01
 ldy #$A0
 lda #44
 jsr {MACPTR}
 jsr {CLRCHN}
END ASM

CLOSE 4

PRINT ""

IF ISAWAVEHDR(RIFFHDR) THEN
  PRINT "this is a wave file."
  GOTO GOTWAVEFILE
END IF

  PRINT "not a wave file"
  GOTO CLEANUP

GOTWAVEFILE:

PRINT ""

IF IsPCM(RIFFHDR) THEN
 PRINT "pcm data format found"
 GOTO GOTPCM
END IF

 PRINT "not pcm"
 GOTO CLEANUP


GOTPCM:
PRINT ""
PRINT PCMBits(RIFFHDR);" bits per sample"
PRINT ""
PRINT "number of channels: ";NumChannels(RIFFHDR)
IF NumChannels(RIFFHDR)=2 THEN PRINT "stereo"
PRINT ""
PRINT "sample rate: ";SampleRate(RIFFHDR)
PRINT ""

CLEANUP:
PRINT "done"

END



